/*
 * Mangrove Server API
 *
 * Submit and retrieve reviews, as well as aggregate statistics about reviews. More information about the values and types can be found in the [Open Reviews Standard](https://mangrove.reviews/standard). For more description and example usage see [Mangrove Demo UI](https://mangrove.reviews) and [Mangrove Client JS Library](https://js.mangrove.reviews/) for a JavaScript wrapper of this API.
 *
 * The version of the OpenAPI document: 0.1.1
 *
 * Generated by: https://openapi-generator.tech
 */

#[derive(Debug, Clone)]
pub struct Configuration {
    pub base_path: String,
    pub user_agent: Option<String>,
    pub client: reqwest::Client,
    pub basic_auth: Option<BasicAuth>,
    pub oauth_access_token: Option<String>,
    pub bearer_access_token: Option<String>,
    pub api_key: Option<ApiKey>,
    // TODO: take an oauth2 token source, similar to the go one
}

pub type BasicAuth = (String, Option<String>);

#[derive(Debug, Clone)]
pub struct ApiKey {
    pub prefix: Option<String>,
    pub key: String,
}

impl Configuration {
    pub fn new() -> Configuration {
        Configuration::default()
    }
}

impl Default for Configuration {
    fn default() -> Self {
        Configuration {
            base_path: "https://api.mangrove.reviews".to_owned(),
            user_agent: Some("OpenAPI-Generator/0.1.1/rust".to_owned()),
            client: reqwest::Client::new(),
            basic_auth: None,
            oauth_access_token: None,
            bearer_access_token: None,
            api_key: None,
        }
    }
}
